Package com.avaya.clientservices.common

## Class ScepConfiguration

- java.lang.Object
- - com.avaya.clientservices.common.ScepConfiguration

-     public class ScepConfiguration
      extends java.lang.Object

  User configuration information for SCEP (Simple Certificate Enrollment Protocol). This protocol is used to retrieve Client Identity certificates from the enrollment server.

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ScepConfiguration()` | Creates an instance of SCEP configuration using default values.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `java.lang.String` | `getCAIdentifier()` |
    `java.lang.String` | `getCertificateCommonName()` |
    `java.lang.String` | `getCertificateDistinguishedName()` | It must begin with a "/" and may include OU, O, L, ST, and C values.
    `int` | `getCertificateKeyLength()` |
    `java.lang.String` | `getChallengePassword()` |
    `java.net.URL` | `getHttpProxy()` |
    `java.net.URL` | `getServerUrl()` | Returns an URL of SCEP (Simple Certificate Enrollment Protocol) server.
    `boolean` | `isRequestWaitingApproval()` |
    `void` | `setCAIdentifier​(java.lang.String caIdentifier)` | Specifies a string value representing an identifier for the CA certificate with which the certificate request is to be signed, if the server hosts multiple certificate authorities.
    `void` | `setCertificateCommonName​(java.lang.String certCN)` | Specifies a string value representing Common name (CN) used in the subject of a SCEP certificate request.
    `void` | `setCertificateDistinguishedName​(java.lang.String certDN)` | Specifies a string value representing the part of the certificate subject Distinguished Name (DN) that will be common to all clients.
    `void` | `setCertificateKeyLength​(int certKeyLen)` | Specifies a numeric value representing the bit length of the public and private keys generated for the SCEP certificate request.
    `void` | `setChallengePassword​(java.lang.String challengePassword)` | Specifies a string value representing the password to be included (if not empty) in the challengePassword attribute of an SCEP certificate request.
    `void` | `setHttpProxy​(java.net.URL httpProxy)` | Specifies a value representing URL of the HTTP proxy server that can be between the client and the SCEP server.
    `void` | `setRequestWaitingApproval​(boolean certWait)` | Specifies a boolean value representing the client behavior if the SCEP server indicates that the certificate request is pending manual approval.
    `void` | `setServerUrl​(java.net.URL serverUrl)` | Specifies an URL of SCEP (Simple Certificate Enrollment Protocol) server.

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ScepConfiguration

          public ScepConfiguration()

      Creates an instance of SCEP configuration using default values.

  - ### Method Detail

    - #### getServerUrl

          public java.net.URL getServerUrl()

      Returns an URL of SCEP (Simple Certificate Enrollment Protocol) server. This URL is used to download PKCS #12 file containing an identity certificate and its private key.
      Returns:
        the SCEP Server URL for certificate enrollment.

    - #### setServerUrl

          public void setServerUrl​(java.net.URL serverUrl)

      Specifies an URL of SCEP (Simple Certificate Enrollment Protocol) server. This URL is used to download PKCS #12 file containing an identity certificate and its private key.
      Parameters:
        `serverUrl` - an URL of the SCEP server

    - #### getHttpProxy

          public java.net.URL getHttpProxy()

      Returns:
        a value representing URL of the HTTP proxy server that can be between the client and the SCEP server.

    - #### setHttpProxy

          public void setHttpProxy​(java.net.URL httpProxy)

      Specifies a value representing URL of the HTTP proxy server that can be between the client and the SCEP server.
      Parameters:
        `httpProxy` - HTTP proxy server

    - #### getCertificateCommonName

          public java.lang.String getCertificateCommonName()

      Returns:
        string value representing Common name (CN) used in the subject of a SCEP certificate request.

    - #### setCertificateCommonName

          public void setCertificateCommonName​(java.lang.String certCN)

      Specifies a string value representing Common name (CN) used in the subject of a SCEP certificate request.
      Parameters:
        `certCN` - Common name (CN) of a SCEP certificate request.

    - #### getCertificateDistinguishedName

          public java.lang.String getCertificateDistinguishedName()

      It must begin with a "/" and may include OU, O, L, ST, and C values.

      The default value is the empty string. It is recommended that a forward-slash character "/" is used as a separator between components, as commas have been found not to work with some servers.

      Returns:
        a string value representing the part of the certificate subject that will be common to all clients.

    - #### setCertificateDistinguishedName

          public void setCertificateDistinguishedName​(java.lang.String certDN)

      Specifies a string value representing the part of the certificate subject Distinguished Name (DN) that will be common to all clients.

      It must begin with a "/" and may include OU, O, L, ST, and C values.

      The default value is the empty string. It is recommended that a forward-slash character "/" is used as a separator between components, as commas have been found not to work with some servers.

      Parameters:
        `certDN` - The certificate subject Distinguished Name (DN)

    - #### getCAIdentifier

          public java.lang.String getCAIdentifier()

      Returns:
        a string value representing an identifier for the CA certificate with which the certificate request is to be signed, if the server hosts multiple certificate authorities.

    - #### setCAIdentifier

          public void setCAIdentifier​(java.lang.String caIdentifier)

      Specifies a string value representing an identifier for the CA certificate with which the certificate request is to be signed, if the server hosts multiple certificate authorities.
      Parameters:
        `caIdentifier` - An identifier of the CA certificate

    - #### getChallengePassword

          public java.lang.String getChallengePassword()

      Returns:
        a string value representing the password to be included (if not empty) in the challengePassword attribute of an SCEP certificate request.

    - #### setChallengePassword

          public void setChallengePassword​(java.lang.String challengePassword)

      Specifies a string value representing the password to be included (if not empty) in the challengePassword attribute of an SCEP certificate request.
      Parameters:
        `challengePassword` - The value of enrollment password.

    - #### getCertificateKeyLength

          public int getCertificateKeyLength()

      Returns:
        a numeric value representing the bit length of the public and private keys generated for the SCEP certificate request.

    - #### setCertificateKeyLength

          public void setCertificateKeyLength​(int certKeyLen)

      Specifies a numeric value representing the bit length of the public and private keys generated for the SCEP certificate request.
      Parameters:
        `certKeyLen` - The length of the public and private keys

    - #### isRequestWaitingApproval

          public boolean isRequestWaitingApproval()

      Returns:
        a boolean value representing the client behavior if the SCEP server indicates that the certificate request is pending manual approval. If false then the SCEP server will be periodically polled in the background. Provide an indication that the certificate request is pending but do not prevent the application from being used. If false then the application is prevented from being used until a certificate is received or the request is rejected.

    - #### setRequestWaitingApproval

          public void setRequestWaitingApproval​(boolean certWait)

      Specifies a boolean value representing the client behavior if the SCEP server indicates that the certificate request is pending manual approval. If true then the SCEP server will be periodically polled in the background. Provide an indication that the certificate request is pending but do not prevent the application from being used. If false then the application is prevented from being used until a certificate is received or the request is rejected.
      Parameters:
        `certWait` - Wait for certificate approval